Package serp.bytecode

# Class CmpInstruction

java.lang.Object
serp.bytecode.Instruction
serp.bytecode.TypedInstruction
serp.bytecode.CmpInstruction

All Implemented Interfaces:
  `BCEntity`, `VisitAcceptor`

public class CmpInstruction extends TypedInstruction
An instruction comparing two stack values. Examples include `lcmp, fcmpl`, etc.

Author:
  Abe White

## Method Summary

Modifier and Type
Method
Description
`void`
`acceptVisit(BCVisitor visit)`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.
`int`
`getLogicalStackChange()`
Return the logical number of stack positions changed by this instruction.
`int`
`getNaNValue()`
Return the number that will be placed on the stack if this instruction is of type float or double and one of the operands is NaN.
`int`
`getStackChange()`
Return the number of stack positions this instruction pushes or pops during its execution.
`String`
`getTypeName()`
Return the type name for this instruction.
`CmpInstruction`
`setNaNValue(int nan)`
Set the number that will be placed on the stack if this instruction is of type float or double and one of the operands is NaN.
`TypedInstruction`
`setType(String type)`
Set the type of this instruction.

### Methods inherited from class serp.bytecode.TypedInstruction

`getType, getTypeBC, setType, setType`

### Methods inherited from class serp.bytecode.Instruction

`equalsInstruction, getByteIndex, getClassLoader, getCode, getLineNumber, getName, getOpcode, getPool, getProject, isValid`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getLogicalStackChange

public int getLogicalStackChange()
Description copied from class: `Instruction`
Return the logical number of stack positions changed by this instruction. In other words, ignore weirdness with longs and doubles taking two stack positions.

Overrides:
  `getLogicalStackChange` in class `Instruction`

### getStackChange

public int getStackChange()
Description copied from class: `Instruction`
Return the number of stack positions this instruction pushes or pops during its execution.

Overrides:
  `getStackChange` in class `Instruction`
Returns:
  0 if the stack is not affected by this instruction, a positive number if it pushes onto the stack, and a negative number if it pops from the stack

### getTypeName

public String getTypeName()
Description copied from class: `TypedInstruction`
Return the type name for this instruction. If the type has not been set, this method will return null.

Specified by:
  `getTypeName` in class `TypedInstruction`

### setType

public TypedInstruction setType(String type)
Description copied from class: `TypedInstruction`
Set the type of this instruction. Types that have no direct support will be converted accordingly.

Specified by:
  `setType` in class `TypedInstruction`
Returns:
  this instruction, for method chaining

### getNaNValue

public int getNaNValue()
Return the number that will be placed on the stack if this instruction is of type float or double and one of the operands is NaN. For FCMPG or DCMPG, this value will be 1; for FCMPL or DCMPL this value will be -1. For LCMP or if the type is unset, this value will be 0.

### setNaNValue

public CmpInstruction setNaNValue(int nan)
Set the number that will be placed on the stack if this instruction is of type float or double and one of the operands is NaN. For FCMPG or DCMPG, this value should be 1; for FCMPL or DCMPL this value should be -1. For LCMP, this value should be 0.

Returns:
  this instruction, for method chaining

### acceptVisit

public void acceptVisit(BCVisitor visit)
Description copied from interface: `VisitAcceptor`
Accept a visit from a `BCVisitor`, calling the appropriate methods to notify the visitor that it has entered this entity, and to provide it with the proper callbacks for each sub-entity owned by this one.

Specified by:
  `acceptVisit` in interface `VisitAcceptor`
Overrides:
  `acceptVisit` in class `Instruction`